//Practice with murmurhash!

#include <stdint.h>
#include <stdio.h>
#include "murmur3.h"

//I'm defining this using a compile-time constant.
//You can use a normal variable with a constant,
//or you can have the seed rerandomized each time.

#define HASH_SEED 889689427	

int main() {

	char* str1 = "hello";

	char* str2 = "jello";

	char* str3 = "a";

	//declare a 2-element array for output of murmurhash
	uint64_t hashOutput[2];

    MurmurHash3_x64_128(str1, 5, HASH_SEED, hashOutput);


	printf("------------------------\nString: %s\nHash 1: %lx\nHash 2: %lx\n", str1, hashOutput[0], hashOutput[1]);

    MurmurHash3_x64_128(str2, 5, HASH_SEED, hashOutput);
	printf("------------------------\nString: %s\nHash 1: %lx\nHash 2: %lx\n", str2, hashOutput[0], hashOutput[1]);

    MurmurHash3_x64_128(str3, 1, HASH_SEED, hashOutput);
	printf("------------------------\nString: %s\nHash 1: %lx\nHash 2: %lx\n", str3, hashOutput[0], hashOutput[1]);

	printf("\n");

	//now let's change the seed we pass!
	//just for demonstration---you don't want to do this in your program
    MurmurHash3_x64_128(str1, 5, HASH_SEED+1, hashOutput);
	printf("--------[2nd seed]--------\nString: %s\nHash 1: %lx\nHash 2: %lx\n", str1, hashOutput[0], hashOutput[1]);

    MurmurHash3_x64_128(str2, 5, HASH_SEED+1, hashOutput);
	printf("--------[2nd seed]--------\nString: %s\nHash 1: %lx\nHash 2: %lx\n", str2, hashOutput[0], hashOutput[1]);

    MurmurHash3_x64_128(str3, 1, HASH_SEED+1, hashOutput);
	printf("--------[2nd seed]--------\nString: %s\nHash 1: %lx\nHash 2: %lx\n", str3, hashOutput[0], hashOutput[1]);

	printf("\n");

    MurmurHash3_x64_128(str1, 5, HASH_SEED, hashOutput);
	printf("------------------------\nString: %s\nHash 1: %lx\nHash 2: %lx\n", str1, hashOutput[0], hashOutput[1]);
}
